=== dists/debian/changelog ===
xoreos (0.0.6-1) unstable; urgency=low

  * New upstream release

 -- Sven Hesse <drmccoy@drmccoy.de>  Mon, 03 Aug 2020 00:00:00 +0200

xoreos (0.0.5-1) unstable; urgency=low

  * New upstream release

 -- Sven Hesse <drmccoy@drmccoy.de>  Tue, 03 Jul 2018 00:00:00 +0200

xoreos (0.0.4-1) unstable; urgency=low

  * New upstream release

 -- Sven Hesse <drmccoy@drmccoy.de>  Mon, 01 Feb 2016 00:00:00 +0100

xoreos (0.0.3-1) unstable; urgency=low

  * New upstream release

 -- Sven Hesse <drmccoy@drmccoy.de>  Wed, 30 Sep 2015 00:00:00 +0200

xoreos (0.0.2-1) unstable; urgency=low

  * Initial release

 -- Sven Hesse <drmccoy@drmccoy.de>  Mon, 27 Jul 2015 09:49:47 +0200
